// sterownik LCD pasujacy do arduino UNO zklawiszami po analogu 
// sterowniae przekaznikiem pin 3
//wejscie z sensorow DS18B20 na pin 2 pullup 4,7k do vcc
// zapuisje w eeprom ostatnie nastawy
//wylaczy sie gdy w odczytana temperatura mniejsza niz 10'c = uszkdozny sensor
// Include the libraries we need
#include <OneWire.h>
#include <DallasTemperature.h>
#include <LiquidCrystal.h>
#include <DFR_LCD_Keypad.h>
#include <EEPROM.h>

// Data wire is plugged into port 2 on the Arduino
#define ONE_WIRE_BUS 2
#define TEMPERATURE_PRECISION 9
// Setup a oneWire instance to communicate with any OneWire devices (not just Maxim/Dallas temperature ICs)
OneWire oneWire(ONE_WIRE_BUS);
// Pass our oneWire reference to Dallas Temperature.
DallasTemperature sensors(&oneWire);
// arrays to hold device addresses
DeviceAddress insideThermometer, outsideThermometer, kolejny;
// lcd setup
LiquidCrystal lcd(8,9,4,5,6,7); 
// initialise the keypad
DFR_LCD_Keypad keypad(A0, &lcd);
int last_key, key;
// koniec ustawiania LCD
float tempS;
float tempON=21,tempOFF;
float tempC2;

void setup(void)
{

tempS = EEPROM.read(10);
if(tempS>30){
  tempS=21;
}
EEPROM.write(10, tempS);

pinMode(3, OUTPUT);   // przekazniki
digitalWrite (3, HIGH);

  // start serial port
  Serial.begin(9600);
  Serial.print(tempS);
  Serial.println(" Wartosc temperatury w eepromie ");

  // Start up the library
  sensors.begin();
   lcd.begin(16,2);
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Start systemu");
  
  // locate devices on the bus
  Serial.print("Locating devices...");
  Serial.print("Found ");
  Serial.print(sensors.getDeviceCount(), DEC);
  Serial.println(" devices.");

  // report parasite power requirements
  Serial.print("Parasite power is: ");
  if (sensors.isParasitePowerMode()) Serial.println("ON");
  else Serial.println("OFF");


  if (!sensors.getAddress(insideThermometer, 0)) Serial.println("Unable to find address for Device 0");
  if (!sensors.getAddress(outsideThermometer, 1)) Serial.println("Unable to find address for Device 1");
  if (!sensors.getAddress(kolejny, 2)) Serial.println("Unable to find address for Device 1");
  Serial.print("Device 0 Address: ");
  printAddress(insideThermometer);
  Serial.println();

  Serial.print("Device 1 Address: ");
  printAddress(outsideThermometer);
  Serial.println();
  Serial.print("Device 2 Address: ");
  printAddress(kolejny);
  Serial.println();
 lcd.clear();
 lcd.setCursor(0,0);
 lcd.print("Ilosc sensorow ");
 lcd.print(sensors.getDeviceCount(), DEC);

 delay(1000);
 tempON=tempS-1;
 tempOFF=tempS+1;
  // set the resolution to 9 bit per device
  sensors.setResolution(insideThermometer, TEMPERATURE_PRECISION);
  sensors.setResolution(outsideThermometer, TEMPERATURE_PRECISION);
 sensors.setResolution(kolejny, TEMPERATURE_PRECISION);
}

// function to print a device address
void printAddress(DeviceAddress deviceAddress)
{
  for (uint8_t i = 0; i < 8; i++)
  {
    // zero pad the address if necessary
    if (deviceAddress[i] < 16) Serial.print("0");
    Serial.print(deviceAddress[i], HEX);
  }
}

// function to print the temperature for a device
void printTemperature(DeviceAddress deviceAddress)
{
  float tempC = sensors.getTempC(deviceAddress);
  Serial.print("Temp C: ");
  Serial.print(tempC);
  //Serial.print(" Temp F: ");
  //Serial.print(DallasTemperature::toFahrenheit(tempC));
}

// function to print a device's resolution
void printResolution(DeviceAddress deviceAddress)
{
  Serial.print("Resolution: ");
  Serial.print(sensors.getResolution(deviceAddress));
  Serial.println();
}

// main function to print information about a device
void printData(DeviceAddress deviceAddress)
{
  Serial.print("Device Address: ");
  printAddress(deviceAddress);
  Serial.print(" ");
  printTemperature(deviceAddress);
  Serial.println();
}

/*
   Main function, calls the temperatures in a loop.
*/
void loop(void)
{
  // call sensors.requestTemperatures() to issue a global temperature
  // request to all devices on the bus
  Serial.print("Requesting temperatures...");
  sensors.requestTemperatures();
  Serial.println("DONE");

  // print the device information
  printData(insideThermometer);
  printData(outsideThermometer);
  printData(kolejny);
 float tempC = sensors.getTempC(insideThermometer);
   float tempC1 = sensors.getTempC(outsideThermometer);
    tempC2=tempC+tempC1;
  tempC2=tempC2/2;
if (tempC2<tempON) {
  digitalWrite (3, LOW);
}

if (tempC2>tempOFF) {
  digitalWrite (3, HIGH);
}


if (tempC2<12) {
  digitalWrite (3, HIGH);
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("USZKODZONY SENSOR");
  lcd.setCursor(0,1);
  lcd.print("LUB DOM ZAMARZA !");
  delay(5400);
}



  lcd.clear();
  lcd.setCursor(0,0);
 // float tempC = sensors.getTempC(insideThermometer);
  lcd.print("OD:");
 lcd.print(tempON);
 // float tempC1 = sensors.getTempC(outsideThermometer);
 lcd.print(" DO:");
 lcd.print(tempOFF);
   lcd.setCursor(0,1);
  lcd.print("M: ");
  //tempC2=tempC+tempC1;
 // tempC2=tempC2/2;
  lcd.print(tempC2);
  lcd.print("  S:  ");
  lcd.print(digitalRead(3));
delay(700);
// klawisze obsluga 
 last_key = keypad.get_last_key();
  key      = keypad.read_key();
  // only clear and update the LCD if they key state has changed
  if (key != last_key) {
    // key has changed
    
  
    // print the key selection to the LCD
    switch (key) {
      case KEY_RIGHT:
        lcd.print("RIGHT");
        break;
        
      case KEY_UP:
        tempS++;
        tempON=tempS-1;
        tempOFF=tempS+1;
        EEPROM.write(10, tempS);
        break;
        
      case KEY_DOWN:
        tempS--;
        tempON=tempS-1;
        tempOFF=tempS+1;
        EEPROM.write(10, tempS);
        break;
        
      case KEY_LEFT:
        lcd.print("LEFT");
        break;

      case KEY_SELECT:
        //lcd.print("SELECT");
          lcd.clear();
          lcd.setCursor(0,0);
          lcd.print("T1:");
          lcd.print(tempC);
          lcd.print(" T2:");
          lcd.print(tempC1);
          lcd.setCursor(0,1);
          
          delay(2000);
        break;
        
      case KEY_NONE:
      default:
        lcd.print("NONE");
        break;
    }
  }
  



  
}
